
\section{ Installing Bokeh } 

%\begin{figure}[h] 
%	\begin{center} 
%		\includegraphics[width=4in]{Figures/Install/error-no-module-bokeh.png} 
%	\end{center} 
%	\caption{ If Bokeh is not installed, then running the ``user-optimize.py'' script will give the \texttt{ImportError}, ``No module named `bokeh.layouts'''. \label{scr:bokeh-import-error} } 
%\end{figure} 

% One of the prerequisites to run the Python user-optimize code is to have a package named ``Bokeh'' installed on the system. If it is not installed, Python will throw the import error shown in \fig{scr:bokeh-import-error}. Fortunately, installing it is extremely easy. \\

One of the prerequisites to run the Python user-optimize code is to have a package named ``Bokeh'' installed on the system. If it is not installed, Python will throw an import error. Fortunately, installing it is extremely easy. \\

%\subsection{ Using Anaconda to Install Bokeh } 

The most straight-forward method to install Bokeh is using the Anaconda install command. Open a Terminal on Linux (using \texttt{Ctrl + Alt + T}), or the Command Prompt on Windows (Windows: first use \texttt{Win + R}, then type ``cmd'', and then hit Enter). \\

Next, type the following command: \\

\texttt{conda install bokeh} \\

If Anaconda is installed, and if all works well, then Bokeh should now be installed, allowing our \texttt{user-optimize.py} to run. \\

% Otherwise, if this approach fails, or if Anaconda is not the platform being used, then there is a pure Python approach, which we will not bother explaining here; however, we strongly advise using the ``conda'' command because it is \textit{much} simpler and less painful than the pure Python approach. \\


%\subsection{ Installing Bokeh with Plain Python } 
%
%This second method is more complicated because it requires multiple steps, and multiple dependencies. However, if you are up for the challenge, then go ahead and follow these steps. \\
%
%First, download Bokeh. There are two methods. One is to go to: \\
%
%\url{github.com/bokeh/bokeh} \\
%
%\noindent , click ``Clone or download,'' and then click ``Download ZIP.'' The ZIP must be extracted before using, and that involves using some extracting software, such as Windows Explorer. As a result, Ruvim's favorite Python approach is the GIT method - super easy. First, make sure GIT is installed. On an Ubuntu Linux, the simple command ``sudo apt-get install git'' will do the trick. If on a Windows, a GIT installer may be downloaded from the page: \\
%
%\url{git-scm.com/downloads} \\
%
%The next step is very easy as well. Open the Terminal (Mac, Linux) or the Command Prompt (Windows), and change into some directory where to save the Bokeh installation files. To open the terminal, use \textt{Ctrl + Alt + T} on Linux, or on Windows use \texttt{Win + R}, then type ``cmd'' and hit Enter. To change into the downloads folder, on Linux type ``cd ~/Downloads'' into the Terminal, while on Windows, type ``cd \%userprofile\%/Downloads'' into Command Prompt. \\
%
%Now is the time to use GIT to download Bokeh. This command is the same for both Windows and Linux: \\
%
%\texttt{git clone } \url{https://github.com/bokeh/bokeh.git} \\
%
%The package will take a moment to download. \\
%
%Next, the software ``npm'' and ``Node.js'' must be installed. On Ubuntu Linux, these can be installed using \\
%
%\texttt{sudo apt-get install npm node} \\
%
%\noindent on Ubuntu Linux \cite{Bokeh_doc_setup}. On Windows, download and install NPM and Node.js using one of the options on the Node.js web pages: \\
%
%\url{nodejs.org/en/download} \\
%
%\noindent , but you will need to restart Command Prompt (and type \texttt{cd \%userprofile\%/Downloads/bokeh} again) after installing. \\
%
%Once NPM and Node.js are installed and ready to go, this other package named ``gulp'' must be installed. Change into the ``bokeh/bokehjs'' folder (so, if the Terminal or the Command Prompt is already in the ``bokeh'' folder, then just type \texttt{cd bokehjs} to do that), and type \\
%
%\texttt{npm install gulp} \\
%
%\noindent to install it globally. Next, to build BokehJS, type the following to install BokehJS (required for Bokeh to work): \\
%
%\texttt{gulp build} \\
%
%If that command fails with the error \texttt{Cannot find module 'coffee-script/register'}, then try installing coffee-script first, using \\
%
%\texttt{npm install -g coffee-script} \\
%
%\noindent and \textit{then} run the command \texttt{gulp build} to install BokehJS. If that does not fix it, try \\
%
%\texttt{npm install --save-dev coffee-script} \\
%
%\noindent and try \texttt{gulp build} again. If it says \texttt{Error: Cannot find module 'gulp-task-listing'}, then run \texttt{npm install -g gulp-task-listing}, or \texttt{npm install --save-dev gulp-task-listing}. The ``--save-dev'' flag was the one that seemed to work for us. If it encounters other similar errors, such as \texttt{Error: Cannot find module 'run-sequence'}, then just install the missing module using this same command that works. For example, \texttt{npm install --save-dev run-sequence} and try \texttt{gulp install} again. For us, aside from ``gulp-task-listing'' and ``run-sequence'', we also had to install ``del'', ``yargs'', ``gulp-typescript'', ``underscore'', ``browserify'', ``gulp-rename'', ``vinyl-transform'', ``gulp-replace'', ``gulp-uglify'', ``vinyl-source-stream'', ``vinyl-buffer'', ``gulp-change'', ``gulp-insert'', ``root-require'', ``gulp-if'', ``gulp-newer'', ``gulp-coffee'', \textbf{``gulp-less''}. This last package did not install. It said ``Please try running this command again as root/Administrator.'' However, running Command Prompt as an administrator did not solve the issue. We were not able to figure this out yet, but someone not using Anaconda may figure it out. If any other errors come up, copy the most unique part of the error to the clipboard, go to Google, type ``bokeh '', and paste the error right after that. Hopefully, all issues can be resolved. \\
%
%Next, change back into the ``bokeh'' folder, and invoke Python to install the package. So, use \\
%
%\texttt{cd ~/Downloads/bokeh} \\
%
%\noindent on Linux, or \\
%
%\texttt{cd \%userprofile\%/Downloads/bokeh} \\
%
%\noindent on Windows, to change into the Bokeh folder. Finally, invoke Python to install the package using the installer script ``setup.py'', which is part of the package: \\
%
%\texttt{python setup.py install} \\
%
%\noindent This way, the Bokeh library can be installed, and interactive plots in Python can be used! However, the Anaconda approach is so much less painful - just use Anaconda if you are not using it already. \\


